#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import numpy as np
import math

import sys
from pathlib import PurePath
#Start to import others .py code from others directory
lcode = PurePath(__file__)
datalocation = lcode.parents[2].as_posix() + '/'
if  (lcode.parents[1].as_posix() in sys.path)  is False:
    sys.path.insert(0,  lcode.parents[1].as_posix())

#get std values for the current data arrays
def get_std(data):
    """
    Get the std of the data array.
    """
    return np.std(data,axis=0)/math.sqrt(len(data[:,0])-1)

# get the label associated to the methodname input (str)
def get_label(methodname):
    """
    Transform the methodname into a label for plot.
    """
    if methodname == "thompson":
        label_object = r'Thompson'
    elif methodname == "aim":
        label_object=r'AIM'
    else:
        label_object = methodname
    return label_object
    
    
    
    
    
    