#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import argparse
from argparse import RawTextHelpFormatter

list_str = ' thompson \,  AIM \n'

def init_bandit_algo_argpasre():
    """
    Initialize the argument parser for configuring the bandit algorithm.

    Description:
    - '--thetas': The mean value of the bandit arm. It can be set to -1 for random values (not limited to 0 or 1), -2 for random values with a maximum separation of 0.2. 
                  If '--thetas' is a list, the values inside will be used, and 'K' will be adjusted to the size of the list.
    - '--methodname': The method specified for the bandit algorithm. Available method names are: [list of available method names].
    - '--K': The number of bandit arms in the problem. In any case, it will be set to the length of 'thetas' if 'thetas' is a list. If not, 'K' controls the number of arms.
    - '--ditsrbandit': The distribution used by the arms.
    """
    parser = argparse.ArgumentParser(description='main in order to generate parameters', formatter_class=RawTextHelpFormatter)
    parser.add_argument('--thetas', type=float, help='mean value of the arm bandit, it can be -1 if so randoms values are drawn (not 0 or 1), -2 it will be random values in with a maximal separation of 0.2, if its a list the values inside will be used and K will be adjusted to thesize of the list', required=True)
    parser.add_argument('--methodname', type=str, required=True, help='method specified for the bandit algorithm method names available are the following: ' + str(list_str) + ' \n')
    parser.add_argument('--K', type=int, default=2, help='Number of amr bandit in the probelm in any case it will be reside as len(thetas) if thetas is a list if not K contromlls the number of arms ')
    parser.add_argument('--ditsrbandit', type=str, default='gaussian', help='distribution used by the arm to pull rewards')
    parser.add_argument('--horizon', type=float, default=-1.0, help='horzion for klucbplusplus')
    return parser